<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package cat_groomer
 */

function cat_groomer_body_classes( $cat_groomer_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$cat_groomer_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$cat_groomer_classes[] = 'no-sidebar';
	}

	$cat_groomer_classes[] = cat_groomer_sidebar_layout();

	return $cat_groomer_classes;
}
add_filter( 'body_class', 'cat_groomer_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function cat_groomer_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'cat_groomer_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function cat_groomer_get_post_choices() {
	$cat_groomer_choices = array( '' => esc_html__( '--Select--', 'cat-groomer' ) );
	$cat_groomer_args    = array( 'numberposts' => -1 );
	$cat_groomer_posts   = get_posts( $cat_groomer_args );

	foreach ( $cat_groomer_posts as $cat_groomer_post ) {
		$cat_groomer_id             = $cat_groomer_post->ID;
		$cat_groomer_title          = $cat_groomer_post->post_title;
		$cat_groomer_choices[ $cat_groomer_id ] = $cat_groomer_title;
	}

	return $cat_groomer_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function cat_groomer_get_page_choices() {
	$cat_groomer_choices = array( '' => esc_html__( '--Select--', 'cat-groomer' ) );
	$cat_groomer_pages   = get_pages();

	foreach ( $cat_groomer_pages as $cat_groomer_page ) {
		$cat_groomer_choices[ $cat_groomer_page->ID ] = $cat_groomer_page->post_title;
	}

	return $cat_groomer_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function cat_groomer_get_post_cat_choices() {
	$cat_groomer_choices = array( '' => esc_html__( '--Select--', 'cat-groomer' ) );
	$cat_groomer_cats    = get_categories();

	foreach ( $cat_groomer_cats as $cat_groomer_cat ) {
		$cat_groomer_choices[ $cat_groomer_cat->term_id ] = $cat_groomer_cat->name;
	}

	return $cat_groomer_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function cat_groomer_get_post_donation_form_choices() {
	$cat_groomer_choices = array( '' => esc_html__( '--Select--', 'cat-groomer' ) );
	$cat_groomer_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $cat_groomer_posts as $cat_groomer_post ) {
		$cat_groomer_choices[ $cat_groomer_post->ID ] = $cat_groomer_post->post_title;
	}
	return $cat_groomer_choices;
}

if ( ! function_exists( 'cat_groomer_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function cat_groomer_excerpt_length( $cat_groomer_length ) {
		if ( is_admin() ) {
			return $cat_groomer_length;
		}

		return get_theme_mod( 'cat_groomer_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'cat_groomer_excerpt_length', 999 );

if ( ! function_exists( 'cat_groomer_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function cat_groomer_excerpt_more( $cat_groomer_more ) {
		if ( is_admin() ) {
			return $cat_groomer_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'cat_groomer_excerpt_more' );

if ( ! function_exists( 'cat_groomer_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function cat_groomer_sidebar_layout() {
		$cat_groomer_sidebar_position      = get_theme_mod( 'cat_groomer_sidebar_position', 'right-sidebar' );
		$cat_groomer_sidebar_position_post = get_theme_mod( 'cat_groomer_post_sidebar_position', 'right-sidebar' );
		$cat_groomer_sidebar_position_page = get_theme_mod( 'cat_groomer_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$cat_groomer_sidebar_position = $cat_groomer_sidebar_position_post;
		} elseif ( is_page() ) {
			$cat_groomer_sidebar_position = $cat_groomer_sidebar_position_page;
		}

		return $cat_groomer_sidebar_position;
	}
}

if ( ! function_exists( 'cat_groomer_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function cat_groomer_is_sidebar_enabled() {
		$cat_groomer_sidebar_position      = get_theme_mod( 'cat_groomer_sidebar_position', 'right-sidebar' );
		$cat_groomer_sidebar_position_post = get_theme_mod( 'cat_groomer_post_sidebar_position', 'right-sidebar' );
		$cat_groomer_sidebar_position_page = get_theme_mod( 'cat_groomer_page_sidebar_position', 'right-sidebar' );

		$cat_groomer_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $cat_groomer_sidebar_position ) {
				$cat_groomer_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $cat_groomer_sidebar_position || 'no-sidebar' === $cat_groomer_sidebar_position_post ) {
				$cat_groomer_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $cat_groomer_sidebar_position || 'no-sidebar' === $cat_groomer_sidebar_position_page ) {
				$cat_groomer_sidebar_enabled = false;
			}
		}
		return $cat_groomer_sidebar_enabled;
	}
}

if ( ! function_exists( 'cat_groomer_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function cat_groomer_get_homepage_sections() {
		$cat_groomer_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'cat-groomer' ),
			'product' => esc_html__( 'cat-groomer Section', 'cat-groomer' ),
		);
		return $cat_groomer_sections;
	}
}

/**
 * Renders customizer section link
 */
function cat_groomer_section_link( $cat_groomer_section_id ) {
	$cat_groomer_section_name      = str_replace( 'cat_groomer_', ' ', $cat_groomer_section_id );
	$cat_groomer_section_name      = str_replace( '_', ' ', $cat_groomer_section_name );
	$cat_groomer_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $cat_groomer_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $cat_groomer_starting_notation . $cat_groomer_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function cat_groomer_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'cat_groomer_section_link_css' );

/**
 * Breadcrumb.
 */
function cat_groomer_breadcrumb( $cat_groomer_args = array() ) {
	if ( ! get_theme_mod( 'cat_groomer_enable_breadcrumb', true ) ) {
		return;
	}

	$cat_groomer_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $cat_groomer_args );
}
add_action( 'cat_groomer_breadcrumb', 'cat_groomer_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function cat_groomer_breadcrumb_trail_print_styles() {
	$cat_groomer_breadcrumb_separator = get_theme_mod( 'cat_groomer_breadcrumb_separator', '/' );

	$cat_groomer_style = '
		.trail-items li::after {
			content: "' . $cat_groomer_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$cat_groomer_style = apply_filters( 'cat_groomer_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $cat_groomer_style ) ) );

	if ( $cat_groomer_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $cat_groomer_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'cat_groomer_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function cat_groomer_render_posts_pagination() {
	$cat_groomer_is_pagination_enabled = get_theme_mod( 'cat_groomer_enable_pagination', true );
	if ( $cat_groomer_is_pagination_enabled ) {
		$cat_groomer_pagination_type = get_theme_mod( 'cat_groomer_pagination_type', 'default' );
		if ( 'default' === $cat_groomer_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'cat_groomer_posts_pagination', 'cat_groomer_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function cat_groomer_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'cat_groomer_post_navigation', 'cat_groomer_render_post_navigation' );

/**
 * Adds footer copyright text.
 */
function cat_groomer_output_footer_copyright_content() {
    $cat_groomer_theme_data = wp_get_theme();
    $cat_groomer_copyright_text = get_theme_mod('cat_groomer_footer_copyright_text');

    if (!empty($cat_groomer_copyright_text)) {
        $cat_groomer_text = esc_html($cat_groomer_copyright_text);
    } else {

    	$cat_groomer_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/free-pet-wordpress-theme','cat-groomer')) . '" target="_blank"> ' . esc_html($cat_groomer_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'cat-groomer') . '&nbsp;<a target="_blank" href="' . esc_url($cat_groomer_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($cat_groomer_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $cat_groomer_default_text .= sprintf(esc_html__(' | Powered by %s', 'cat-groomer'), '<a href="' . esc_url(__('https://wordpress.org/', 'cat-groomer')) . '" target="_blank">WordPress</a>. ');

        $cat_groomer_text = $cat_groomer_default_text;
    }
    ?>
    <span><?php echo wp_kses_post($cat_groomer_text); ?></span>
    <?php
}
add_action('cat_groomer_footer_copyright', 'cat_groomer_output_footer_copyright_content');

/* Footer Social Icons */ 
function cat_groomer_footer_social_links() {

    if ( get_theme_mod('cat_groomer_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('cat_groomer_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('cat_groomer_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('cat_groomer_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'cat-groomer'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('cat_groomer_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('cat_groomer_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('cat_groomer_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'cat-groomer'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('cat_groomer_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('cat_groomer_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('cat_groomer_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'cat-groomer'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('cat_groomer_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('cat_groomer_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('cat_groomer_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'cat-groomer'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('cat_groomer_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('cat_groomer_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('cat_groomer_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'cat-groomer'); ?></span>
						</a>
					<?php } ?>
				</div>
			</div>
            <?php
    }
}
add_action('wp_footer', 'cat_groomer_footer_social_links');

if ( ! function_exists( 'cat_groomer_footer_widget' ) ) :
	function cat_groomer_footer_widget() {
		$cat_groomer_footer_widget_column = get_theme_mod('cat_groomer_footer_widget_column','4');

		$cat_groomer_column_class = '';
		if ($cat_groomer_footer_widget_column == '1') {
			$cat_groomer_column_class = 'one-column';
		} elseif ($cat_groomer_footer_widget_column == '2') {
			$cat_groomer_column_class = 'two-columns';
		} elseif ($cat_groomer_footer_widget_column == '3') {
			$cat_groomer_column_class = 'three-columns';
		} else {
			$cat_groomer_column_class = 'four-columns';
		}
	
		if($cat_groomer_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($cat_groomer_column_class); ?> wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($cat_groomer_i = 1; $cat_groomer_i <= $cat_groomer_footer_widget_column; $cat_groomer_i++) {
					if (is_active_sidebar('cat-groomer-footer-widget-' . $cat_groomer_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($cat_groomer_i = 1; $cat_groomer_i <= $cat_groomer_footer_widget_column; $cat_groomer_i++) {
						if (is_active_sidebar('cat-groomer-footer-widget-' . $cat_groomer_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('cat-groomer-footer-widget-' . $cat_groomer_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'cat-groomer'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'cat-groomer'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'cat-groomer'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'cat-groomer'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="categories" class="widget py-3" role="complementary" aria-label="<?php esc_attr_e('footer1', 'cat-groomer'); ?>">
                        <h3 class="widget-title"><?php esc_html_e('Categories', 'cat-groomer'); ?></h3>
                        <ul>
                            <?php wp_list_categories('title_li='); ?>
                        </ul>
                    </aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'cat_groomer_footer_widget', 'cat_groomer_footer_widget' );

function cat_groomer_footer_text_transform_css() {
    $cat_groomer_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4 {
            text-transform: <?php echo esc_html($cat_groomer_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'cat_groomer_footer_text_transform_css');

/**
 * GET START FUNCTION
 */

function cat_groomer_getpage_css($hook) {
	wp_enqueue_script( 'cat-groomer-admin-script', get_template_directory_uri() . '/resource/js/cat-groomer-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'cat-groomer-admin-script', 'cat_groomer_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'cat-groomer-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'cat_groomer_getpage_css' );


add_action('wp_ajax_cat_groomer_dismissable_notice', 'cat_groomer_dismissable_notice');
function cat_groomer_switch_theme() {
    delete_user_meta(get_current_user_id(), 'cat_groomer_dismissable_notice');
}
add_action('after_switch_theme', 'cat_groomer_switch_theme');
function cat_groomer_dismissable_notice() {
    update_user_meta(get_current_user_id(), 'cat_groomer_dismissable_notice', true);
    die();
}

function cat_groomer_deprecated_hook_admin_notice() {
    global $pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'cat-groomer-getting-started' ) {
        return;
    }

    $dismissed = get_user_meta( get_current_user_id(), 'cat_groomer_dismissable_notice', true );
    if ( !$dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Cat Groomer', 'cat-groomer'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Cat Groomer journey to the next level.', 'cat-groomer'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'cat-groomer'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=cat-groomer-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'cat-groomer' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://demo.asterthemes.com/dog-pet-house/"><?php esc_html_e('View Demo', 'cat-groomer') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://asterthemes.com/products/pet-house-wordpress-theme"><?php esc_html_e('Buy Now', 'cat-groomer') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( CAT_GROOMER_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'cat-groomer') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}

add_action( 'admin_notices', 'cat_groomer_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function cat_groomer_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}